# - Try to find FFMPEG
# Once done this will define
#  
#  FFMPEG_FOUND        - system has FFMPEG
#  FFMPEG_INCLUDE_DIR  - the include directory
#  FFMPEG_LIBRARY_DIR  - the directory containing the libraries
#  FFMPEG_LIBRARIES    - Link these to use FFMPEG
#   

SET( FFMPEG_HEADERS avformat.h avcodec.h avutil.h avdevice.h swscale.h )
if( WIN32 )
   SET( FFMPEG_LIBRARIES avformat.lib avcodec.lib avutil.lib avdevice.lib swscale.lib )
   FIND_PATH( FFMPEG_INCLUDE_DIR ${FFMPEG_HEADERS}
              PATHS $ENV{FFMPEGDIR}/include/ffmpeg )
   FIND_PATH( FFMPEG_LIBRARY_DIR ${FFMPEG_LIBRARIES}
              PATHS $ENV{FFMPEGDIR}/lib )
else( WIN32 )
    #FindAvformat
    FIND_PATH( AVFORMAT_INCLUDE_DIR avformat.h
               PATHS /usr/include/
                     /usr/include/libavformat/
                     /usr/include/ffmpeg/
                     /usr/include/ffmpeg/libavformat/ )

    FIND_LIBRARY( AVFORMAT_LIBRARY avformat
                  PATHS /usr/lib/
                        /usr/lib/ffmpeg/ )
    #FindAvcodec
    FIND_PATH( AVCODEC_INCLUDE_DIR avcodec.h
               PATHS /usr/include/
                     /usr/include/libavcodec/
                     /usr/include/ffmpeg/
                     /usr/include/ffmpeg/libavcodec/ )

    FIND_LIBRARY( AVCODEC_LIBRARY avcodec
                  PATHS /usr/lib/
                        /usr/lib/ffmpeg/ )
    #FindAvutil
    FIND_PATH( AVUTIL_INCLUDE_DIR avutil.h
               PATHS /usr/include/
                     /usr/include/libavutil/
                     /usr/include/ffmpeg/
                     /usr/include/ffmpeg/libavutil/ )

    FIND_LIBRARY( AVUTIL_LIBRARY avutil
                  PATHS /usr/lib/
                        /usr/lib/ffmpeg/ )

    #FindAvdevice
    FIND_PATH( AVDEVICE_INCLUDE_DIR avdevice.h
               PATHS /usr/include/
                     /usr/include/libavdevice/
                     /usr/include/ffmpeg/
                     /usr/include/ffmpeg/libavdevice/ )

    FIND_LIBRARY( AVDEVICE_LIBRARY avdevice
                  PATHS /usr/lib/
                        /usr/lib/ffmpeg/ )
    #FindSwscale
    FIND_PATH( SWSCALE_INCLUDE_DIR swscale.h
               PATHS /usr/include/
                     /usr/include/libswscale/
                     /usr/include/ffmpeg/
                     /usr/include/ffmpeg/libswscale/ )

    FIND_LIBRARY( SWSCALE_LIBRARY swscale
                  PATHS /usr/lib/
                        /usr/lib/ffmpeg/ )

endif( WIN32 )

SET( FFMPEG_FOUND FALSE )

IF ( AVFORMAT_INCLUDE_DIR AND AVFORMAT_LIBRARY )
    SET ( AVFORMAT_FOUND TRUE )
ENDIF ( AVFORMAT_INCLUDE_DIR AND AVFORMAT_LIBRARY )

IF ( AVCODEC_INCLUDE_DIR AND AVCODEC_LIBRARY ) 
    SET ( AVCODEC_FOUND TRUE )
ENDIF ( AVCODEC_INCLUDE_DIR AND AVCODEC_LIBRARY )

IF ( AVUTIL_INCLUDE_DIR AND AVUTIL_LIBRARY )
    SET ( AVUTIL_FOUND TRUE )
ENDIF ( AVUTIL_INCLUDE_DIR AND AVUTIL_LIBRARY )

IF ( AVDEVICE_INCLUDE_DIR AND AVDEVICE_LIBRARY ) 
    SET ( AVDEVICE_FOUND TRUE )
ENDIF ( AVDEVICE_INCLUDE_DIR AND AVDEVICE_LIBRARY )

IF ( SWSCALE_INCLUDE_DIR AND SWSCALE_LIBRARY )
    SET ( SWSCALE_FOUND TRUE )
ENDIF ( SWSCALE_INCLUDE_DIR AND SWSCALE_LIBRARY )


IF ( WIN32 )
    IF ( FFMPEG_INCLUDE_DIR AND FFMPEG_LIBRARY_DIR )
        SET( FFMPEG_FOUND TRUE )
    ENDIF ( FFMPEG_INCLUDE_DIR AND FFMPEG_LIBRARY_DIR )
ELSE ( WIN32 )
    IF ( AVFORMAT_INCLUDE_DIR OR AVCODEC_INCLUDE_DIR OR AVUTIL_INCLUDE_DIR OR AVDEVICE_FOUND OR SWSCALE_FOUND )
        SET ( FFMPEG_FOUND TRUE )

        SET ( FFMPEG_INCLUDE_DIR
              ${AVFORMAT_INCLUDE_DIR}
              ${AVCODEC_INCLUDE_DIR}
              ${AVUTIL_INCLUDE_DIR}
              ${AVDEVICE_INCLUDE_DIR}
              ${SWSCALE_INCLUDE_DIR} )
        
        SET ( FFMPEG_LIBRARIES 
              ${AVFORMAT_LIBRARY}
              ${AVCODEC_LIBRARY}
              ${AVUTIL_LIBRARY}
              ${AVDEVICE_LIBRARY}
              ${SWSCALE_LIBRARY} )
    ENDIF ( AVFORMAT_INCLUDE_DIR OR AVCODEC_INCLUDE_DIR OR AVUTIL_INCLUDE_DIR OR AVDEVICE_FOUND OR SWSCALE_FOUND )
ENDIF ( WIN32 )

